#****************************************************************************
#**  File     :  /lua/sim/Projectile.lua
#****************************************************************************

local oldProjectile = Projectile
Projectile = Class(oldProjectile) {
    
	
	#OnLostTarget = function(self)
    #    #LOG('Lost Target')
    #    if self.advancedtrack then
    #    	self:Retarget()
    #    else
    #    	oldProjectile.OnLostTarget(self)
    #    end
    #end,

    OnCreate = function(self)
        oldProjectile.OnCreate(self)
        if not (self:GetBlueprint().Physics.TrackTarget) then return end
        #LOG('advanced tracking')
        self.advancedtrack = true
        self:ForkThread(self.LifetimeCounter)
    end, 


	LifetimeCounter = function(self)
		if not self.antiair then return	end
		
    	#local rangedecrement=self.range/self.initLifetime
        
        local target = self:GetTrackingTarget() 
            if target.IncommingDamage then
	        	
	        	if target.IncommingDamage<target:GetHealth()*2 then
	        		target.IncommingDamage=target.IncommingDamage+self.DamageData.DamageAmount
	        		#LOG('incommingadd:'.. target.IncommingDamage)
	        		#LOG(string.format('incommingdamage:%d',target.IncommingDamage))
	        		self.advancedTrackinglock=true
	        	else
	        		self.advancedTrackinglock=nil
	        		self:Retarget()
	        	end
	        	
	        else 
	        	target.IncommingDamage=self.DamageData.DamageAmount
	        	#LOG('incommingNew:'.. target.IncommingDamage)
	        	#LOG(string.format('newincommingdamage:%d',target.IncommingDamage))
	        	self.advancedTrackinglock=true
	        end
        
        #WaitSeconds(1.0)
        
        #while not self:BeenDestroyed() do 
        #	self.range=self.range-rangedecrement
        #	WaitSeconds(1)
        #end
    end,
    
    Retarget = function(self)
  	    local launcher = self:GetLauncher()
  	    if not launcher then self:Destroy() end
    	local aiBrain = launcher:GetAIBrain()
    	#local aiBrain = self:GetAIBrain() 
    	local position = self:GetPosition()
    	#LOG(string.format('range:%d',self.range))
    	local targetlist = aiBrain:GetUnitsAroundPoint( categories.AIR, position, self.range ,'ENEMY') 
        local lasttarget
        local lastratio = nil
    	if targetlist[1] then
          	#self:SetNewTarget(targetlist[1])
          	for k, v in targetlist do
	          	if not v.IsDead() then
		          	local damageratio
	          		if not v.IncommingDamage then
		          		self:SetNewTarget(v)
		          		self:TrackTarget(true)
		          		v.IncommingDamage=self.DamageData.DamageAmount
		          		self.advancedTrackinglock=true
		          		#LOG('newTarget')
		          		return
		          	else
		          		damageratio = v.IncommingDamage/v:GetHealth()
		          	end
		          	
		          	if damageratio < 2 then
		        		self:SetNewTarget(v)
		        		self:TrackTarget(true)
		        		#LOG('newTarget')	
		          		v.IncommingDamage=v.IncommingDamage+self.DamageData.DamageAmount
		          		self.advancedTrackinglock=true
		          		return
		          	elseif not lastratio or lastratio>damageratio then 
		          		lasttarget = v
		          		lastratio = damageratio
		          	end
		        end
		    end
		    
		else
			#LOG('kill')
		    self:Destroy()
        end 
        
      	if lasttarget then 
      		#LOG('newTarget last target')
      		self:SetNewTarget(lasttarget)
      		self:TrackTarget(true)
      	else
      		#LOG('kill')
          	self:Destroy()
      	end
    end,
    
    OnDestroy = function(self)
    	local target = self:GetTrackingTarget()
    	if self.advancedTrackinglock and target and not target:IsDead()  and target.IncommingDamage then #
    		target.IncommingDamage=target.IncommingDamage-self.DamageData.DamageAmount
    		if target.IncommingDamage<=0 then
    			target.IncommingDamage=nil
    		end
    	end	
    	oldProjectile.OnDestroy(self)
    end,
}
